<template>
  <el-main>
    <!--没收物品处理清单-->
    <el-form ref="dataForm" :model="dataForm" label-width="110px" :disabled="isFinish =='2'">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文号">
            <el-input v-model="dataForm.unitName" placeholder="_______没处〔    〕第    号"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="决定书编号">
            <el-input v-model="dataForm.decisionNo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="	当事人">
            <el-input v-model="dataForm.litigant"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="电话">
            <el-input v-model="dataForm.phone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="当事人地址">
        <el-input v-model="dataForm.address"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="执行处置单位">
            <el-input v-model="dataForm.handleOrg"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="处置单位电话">
            <el-input v-model="dataForm.handleOrgPhone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="处置单位地址">
        <el-input v-model="dataForm.handleOrgAddress"></el-input>
      </el-form-item>
<!--      <el-row>-->
<!--        <el-col :span="12">-->
<!--          <el-form-item label="特邀参加人">-->
<!--            <el-input v-model="dataForm.speciallyInvitePerson"></el-input>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--        <el-col :span="12">-->
<!--          <el-form-item label="签字时间">-->
<!--            <el-date-picker-->
<!--                v-model="dataForm.speciallyInvitePersonTime"-->
<!--                type="date"-->
<!--                :value-format="`yyyy-MM-dd`"-->
<!--                style="width: 100%"-->
<!--                placeholder="选择日期">-->
<!--            </el-date-picker>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
<!--      <el-row>-->
<!--        <el-col :span="12">-->
<!--          <el-form-item label="经办人">-->
<!--            <el-select v-model="dataForm.handlerIds" clearable filterable multiple :multiple-limit="2"-->
<!--                       placeholder="请选择" style="width: 100%;" @change="setPersonname($event)">-->
<!--              <el-option-->
<!--                  v-for="item in organPersons"-->
<!--                  :key="item.userId"-->
<!--                  :label="item.realName"-->
<!--                  :value="item.userId"-->
<!--              >-->
<!--                <span style="float: left">{{ item.realName }}</span>-->
<!--                <span style="float: right; color: #8492a6; font-size: 13px">执法证号：{{ item.lawCert }}</span>-->
<!--              </el-option>-->
<!--            </el-select>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
<!--      </el-row>-->
      <el-row>
<!--        <el-col :span="12">-->
<!--          <el-form-item label="经办人签字时间">-->
<!--            <el-date-picker-->
<!--              v-model="dataForm.handlePersonTime"-->
<!--              type="date"-->
<!--              :value-format="`yyyy-MM-dd`"-->
<!--              style="width: 100%"-->
<!--              placeholder="选择日期">-->
<!--            </el-date-picker>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
          <el-form-item label="	音像资料目录">
            <el-input v-model="dataForm.videoPath"></el-input>
          </el-form-item>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="盖章时间">
            <el-date-picker
              v-model="dataForm.executionTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              style="width: 100%"
              placeholder="选择日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label-width="0">
        <el-button @click="openForm">添加物品</el-button>
        <el-table
            :data="dataForm.goodsList"
            style="width: 100%">
          <el-table-column
              label="序号"
              type="index"/>
          <el-table-column
              prop="name"
              label="名称">
          </el-table-column>
          <el-table-column
              prop="number"
              label="数量">
          </el-table-column>
          <el-table-column
              prop="size"
              label="规格（型号）">
          </el-table-column>
          <el-table-column
              prop="handleMode"
              label="处理方式">
          </el-table-column>
          <el-table-column
              prop="handlePlace"
              label="处理地点">
          </el-table-column>
          <el-table-column
            label="操作">
            <template slot-scope="scope">
              <el-button type="text" @click="deleteByRow(scope.$index)">
                <img src="../../../../../assets/lawImg/deleteIconRed.png" alt="">
              </el-button>
            </template>
          </el-table-column>
        </el-table>
      </el-form-item>

    </el-form>
    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" type="primary" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(dataForm)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(dataForm)">下载</el-button>
    </div>
    <ExpropGoodsInventoryFrom :isShow="isShow" @cancell="cancell"></ExpropGoodsInventoryFrom>
    <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
  </el-main>
</template>

<script>
import ExpropGoodsInventoryFrom from './expropGoodsInventory-from'
import {saveObj, getObj} from '@/api/News/expropGoodsInventory'
import {getfindAll} from '@/api/News/useres';
import WordView from "@/views/News/word-view";
import moment from "moment";

export default {
  name: "exprop-goods-inventory",
  props: ['isShowYulan', 'id', 'isFinish', 'processId'],
  components: {
    ExpropGoodsInventoryFrom, WordView
  },
  data() {
    return {
      isShow: false,
      showView: false,
      organPersons: [],
      dataForm: {
        unitName: '',//单位简称
        yeares: '',
        referenceNumber: '',
        decisionNo: '',//决定书编号
        litigant: '',//	当事人姓名
        address: '',//地址
        handleOrg: '',//处置单位
        handleOrgAddress: '',//处置单位地址
        handleOrgPhone: '',//处置单位电话
        videoPath: '',//音像资料地址
        speciallyInvitePerson: '',//特邀参加人
        executionTime: '',
        handlePersonTime: '',
        handlePerson: '',
        handlerIds: '',
        speciallyInvitePersonTime: '',
        goodsList: [],

      }
    }
  },
  created() {
    this.init();
  },
  methods: {
    init() {
      //查询人员
      getfindAll().then((res) => {
        this.organPersons = res.data.data;
      }),
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          this.dataForm = res.data.data;
          // if (this.dataForm.handlerIds != "") {
          //   let ids = [];
          //   this.dataForm.handlerIds.split(",").forEach(o => {
          //     ids.push(parseInt(o));
          //   })
          //   this.dataForm.handlerIds = ids;
          // }
        }
      });
    },
    dataFormSubmit(type) {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.dataForm.registerState = type;
              obj.dataForm.registerId = obj.id;
              obj.dataForm.processId = obj.processId;
              // obj.dataForm.handlerIds = obj.dataForm.handlerIds.toString();
              // if (obj.dataForm.handlerIds.length < 1) {
              //   obj.dataForm.handlePerson = '';
              // }
              saveObj(obj.dataForm).then((res) => {
                if (res.data.code == 0) {
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                }
              })
            })
          } else {
            obj.dataForm.registerState = type;
            obj.dataForm.registerId = obj.id;
            obj.dataForm.processId = obj.processId;
            console.log(obj.dataForm);
            // obj.dataForm.handlerIds = obj.dataForm.handlerIds.toString();
            // if (obj.dataForm.handlerIds.length < 1) {
            //   obj.dataForm.handlePerson = '';
            // }
            saveObj(obj.dataForm).then((res) => {
              if (res.data.code == 0) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              }
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    openForm() {
      this.isShow = true;
    },
    cancell(e, d) {
      this.isShow = e;
      if(d !=undefined){
        this.dataForm.goodsList.push(d)
      }
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/mswpclqd.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/mswpclqd.docx", "没收物品处理清单.docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);

      if (data.speciallyInvitePersonTime != '' && data.speciallyInvitePersonTime != null) {
        data.speciallyInvitePersonTime = moment(data.speciallyInvitePersonTime).format('YYYY年MM月DD日');
      } else {
        data.speciallyInvitePersonTime = '  年  月  日'
      }
      if (data.handlePersonTime != '' && data.handlePersonTime != null) {
        data.handlePersonTime = moment(data.handlePersonTime).format('YYYY年MM月DD日');
      } else {
        data.handlePersonTime = '  年  月  日'
      }

      if (data.executionTime != '' && data.executionTime != null) {
        data.executionTime = moment(data.executionTime).format('YYYY年MM月DD日');
      } else {
        data.executionTime = '  年  月  日'
      }

      let goods = data.goodsList;
      //添加序号
      // goods.forEach(function (e, i) {
      //   if (data.name = )
      //   e.index = i + 1 + "";
      // })

      //物品明细，如果不够7个，补空到7个
      let arr = this.formatArr(goods,7)
      if(goods.length > 5) {
        goods = [...arr]
      }else {
        goods = [...goods,...arr]
      }
      data.goodsList = goods;

      for(let i=1;i <= goods.length;i++) {
        if (goods[i-1].name != null && goods[i-1].name != "") {
          goods[i-1].index = i + '';
        } else {
          goods[i-1].index = '';
        }
      }
      return data;
    },
    formatArr(arr,n) {
      let len = arr.length
      if(n<len) {
        return arr.filter((item,num) => num < n)
      }else {
        return new Array(n - len).fill({
          name: '',
          number: '',
          size: '',
          handleMode: '',
          handlePlace: '',
        })
      }
    },
    cancelWord() {
      this.showView = false;
    },
    // setPersonname(val) {
    //   let names = "";
    //   for (let i in this.organPersons) {
    //     if (val.toString().indexOf(this.organPersons[i].userId) > -1) {
    //       names += this.organPersons[i].realName + ",";
    //     }
    //   }
    //   if (names != "") {
    //     this.dataForm.handlePerson = names.substring(0, names.length - 1);
    //   }
    // },
    deleteByRow(str){
      console.log(str,'str-==')
      this.dataForm.goodsList.splice(str,1)
    },
  }
}
</script>

<style scoped>

</style>
